// C Header File
// Created 2001-06-29; 15:06:48
//Comments by JE
// Handles the Menu... 
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ESC_ROW 0xffbf
#define ESC_KEY 1
#define FCHK 128
#define ENTER_ROW ~((short)(1 << 1))
#define ENTER_KEY (1 << 0)
int menu(void)
{
// Time to get some Y variable.. 
	int menu_y=7; //(Let's start with 7)
	int quit=0;

	static unsigned char menu_pointer[] = {0x00,0x7C,0x62,0x4A,0xC9,0xA2,0x9C,0x00};
	delayt(150000);
// Draw the menu options...
	FontSetSys (F_4x6);
	SetPlane(DARK_PLANE);
	// erases
DrawGrayRect(72,11,159,45,A_NORMAL,COLOR_WHITE);
	// new stuff
	DrawGrayStr (72  , 8 ," START             ",A_NORMAL);
	DrawGrayStr (72  , 18 ," INTRODUCTION/HELP ",A_NORMAL);
	DrawGrayStr (72   ,28 ," OPTIONS           ",A_NORMAL);
	DrawGrayStr (72   ,38 ," QUIT              ",A_NORMAL);
	SetPlane(DARK_PLANE);
	printf_xy (23 , 50, "Use the arrow keys to move the marker  ");
	SetPlane(LIGHT_PLANE);
	printf_xy (23 , 50, "Use the arrow keys to move the marker  ");

	Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
	Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);		
	
	while (quit==0)
	{
		if (_rowread(ARROWS_ROW) & DOWN_KEY)
		{
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			menu_y+=10;
			if (menu_y>37) menu_y=7;
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			beep(500,5);
			delayt(150000);
		}
		if (_rowread(ARROWS_ROW) & UP_KEY)
		{
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			menu_y-=10;
			if (menu_y<7) menu_y=37;
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			beep(500,5);
			delayt(150000);
		}
		if (_rowread(ENTER_ROW) & ENTER_KEY) {
			beep(700,5);
			if (menu_y==7) return 2; // New game
			if (menu_y==17) { // Well.. Instructions...
				// Copy the current screen state (Save_Screen that is =)
				memcpy(virtual_light,GetPlane(LIGHT_PLANE),3840);
				memcpy(virtual_dark,GetPlane(DARK_PLANE),3840);
				// Clear the screen..
				SetPlane(LIGHT_PLANE);
				ClrScr();
				SetPlane(DARK_PLANE);
				ClrScr();
				// INSTRUCTIONS
				// Your goal is to reach the top of
				// the maze, by picking up / placing
				// blocks, and jump on them! Note that
				// you can only pick up the White balls.
				// You'll have a "block" counter up left
				//
				// KEYS
				// Use the arrow keys to move Left/right
				// Push F1 to jump
				// Push F5 to place/pickup a block
				FontSetSys (F_4x6);	
				DrawGrayStr (0 , 5, "INSTRUCTIONS:",A_REPLACE);
				DrawGrayStr (0 , 11, "Your goal in Jes Jumper is to reach the top",A_REPLACE);
				DrawGrayStr (0 , 17, "of the maze by picking up/placing blocks,",A_REPLACE);
				DrawGrayStr (0 , 23, "and jumping on them! Note that you can only",A_REPLACE);
				DrawGrayStr (0 , 29, "pick up the gradient blocks. You'll have a",A_REPLACE);
				DrawGrayStr (0 , 35, "block counter up left.",A_REPLACE);
				DrawGrayStr (0 , 50, "KEYS:",A_REPLACE);
				DrawGrayStr (0 , 56, "Use the arrow keys to move left/right",A_REPLACE);
				DrawGrayStr (0 , 62, "Push 2nd to jump",A_REPLACE);
				DrawGrayStr (0 , 68, "Push <> to place/pick up a block",A_REPLACE);

				
				while (!(_rowread(ENTER_ROW) & ENTER_KEY)) { }
				
				memcpy(GetPlane(LIGHT_PLANE),virtual_light,3840);
				memcpy(GetPlane(DARK_PLANE),virtual_dark,3840);
				delayt(150000);
			}
			if (menu_y==37) {delayt(5000);
				return 1; // Quit
			}
			
			if (menu_y==27) {
				memcpy(virtual_light,GetPlane(LIGHT_PLANE),3840);
				memcpy(virtual_dark,GetPlane(DARK_PLANE),3840);
				SetPlane(DARK_PLANE);
			// new stuff

				if (*sound==TRUE) printf_xy (75  , 8 ," SOUND : ON            ");
				if (*sound==FALSE) printf_xy (75  , 8 ," SOUND : OFF           ");
				if (*deathanim==TRUE) printf_xy (75  , 18 ," DEATH ANIM.: ON        ");
				if (*deathanim==FALSE) printf_xy (75  , 18 ," DEATH ANIM.: OFF       ");
				if (*introanim==TRUE) printf_xy (75  , 28 ," INTRO ANIM.: ON        ");
				if (*introanim==FALSE) printf_xy (75  , 28 ," INTRO ANIM.: OFF       ");				
				printf_xy (75  , 38 ," BACK              ");
				SetPlane(LIGHT_PLANE);
				// new stuff

				printf_xy (75  , 8 ," SOUND :             ");
				printf_xy (75   ,18 ," DEATH ANIM.:              ");
				printf_xy (75   ,28 ," INTRO ANIM.:        ");
				printf_xy (75  , 38 ," BACK              ");
				delayt(150000);
				while (quit==0)
				{
					if (_rowread(ARROWS_ROW) & DOWN_KEY) // down
					{
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
						menu_y+=10;
						if (menu_y>37) menu_y=37;
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_OR);
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_OR);	
						beep(500,2);
						delayt(150000);
					}
					if (_rowread(ARROWS_ROW) & UP_KEY) // up
					{
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
						menu_y-=10;
						if (menu_y<7) menu_y=7;
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_OR);
						Sprite8(66, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_OR);	
						beep(500,2);
						delayt(150000);
					}
					if (_rowread(ENTER_ROW) & ENTER_KEY) {
						beep(900,2);
						if (menu_y==7) {
							if (*sound==FALSE) {
								*sound=TRUE;
							}
							else *sound=FALSE;
							SetPlane(DARK_PLANE);
							if (*sound==TRUE) printf_xy (75  , 8 ," SOUND : ON        ");
							if (*sound==FALSE) printf_xy (75  , 8 ," SOUND : OFF       ");
							delayt(150000);
						}
						if (menu_y==17) {
							if (*deathanim==FALSE) {
								*deathanim=TRUE;
							}
							else *deathanim=FALSE;
							SetPlane(DARK_PLANE);
							if (*deathanim==TRUE) printf_xy (75  , 18 ," DEATH ANIM.: ON        ");
							if (*deathanim==FALSE) printf_xy (75  , 18 ," DEATH ANIM.: OFF       ");
							delayt(150000);
						}
						if (menu_y==27) {
							if (*introanim==FALSE) {
								*introanim=TRUE;
							}
							else *introanim=FALSE;
							SetPlane(DARK_PLANE);
							if (*introanim==TRUE) printf_xy (75  , 28 ," INTRO ANIM.: ON        ");
							if (*introanim==FALSE) printf_xy (75  , 28 ," INTRO ANIM.: OFF       ");
							delayt(150000);
						}						
						if (menu_y==37) quit=1;
					}
				}
				quit=0;
				memcpy(GetPlane(LIGHT_PLANE),virtual_light,3840);
				memcpy(GetPlane(DARK_PLANE),virtual_dark,3840);
				delayt(150000);
				menu_y=27;
			}			
		}
	}
	return 1;
}

int in_game_menu(void) { // Needs to return if we're going to quit or not ya know...
	// this one will froze the game, and load the menu..
	static unsigned char menu_pointer[] = {0x00,0x7C,0x62,0x4A,0xC9,0xA2,0x9C,0x00};
	int menu_y=21,quit=0; //(Let's start with 21)
	
	// Let's start with copying the screen statement:
	memcpy(virtual_light,GetPlane(LIGHT_PLANE),3840);
	memcpy(virtual_dark,GetPlane(DARK_PLANE),3840);
	
	// Now we should have some sort of menu..
	FontSetSys (F_6x8);
	DrawGrayRect (40, 8, 160, 80, COLOR_WHITE, RECT_FILLED);
	DrawGrayLine(40,8,159,8,COLOR_BLACK);
	DrawGrayLine(40,80,159,80,COLOR_BLACK);
	DrawGrayLine(40,8,40,80,COLOR_BLACK);
	DrawGrayLine(159,8,159,80,COLOR_BLACK);	
	DrawGrayStr (51  , 11 ,"    PAUSE      ",A_NORMAL);
	DrawGrayStr (51  , 21 ," RETURN TO GAME",A_NORMAL);
	DrawGrayStr (51  , 31 ," RETURN TO MENU",A_NORMAL);
	DrawGrayStr (51   ,41 ," QUIT TO OS    ",A_NORMAL);

	Sprite8(42, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
	Sprite8(42, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);
	
	// Allright.. let us navigate threw this darn menu ;)
	while (quit==0)
	{
		if (_rowread(ARROWS_ROW) & DOWN_KEY) // DOWN
		{
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			menu_y+=10;
			if (menu_y>41) menu_y=41;
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			delayt(150000);
		}
		if (_rowread(ARROWS_ROW) & UP_KEY) // UP
		{
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			menu_y-=10;
			if (menu_y<21) menu_y=21;
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (DARK_PLANE), SPRT_XOR);
			Sprite8(42, menu_y, 8, menu_pointer, GetPlane (LIGHT_PLANE), SPRT_XOR);	
			delayt(150000);
		}
		if (_rowread(ENTER_ROW) & ENTER_KEY) { // ENTER
			if (menu_y==21) {
				// and now we restore the screen statement.. 
				memcpy(GetPlane(LIGHT_PLANE),virtual_light,3840);
				memcpy(GetPlane(DARK_PLANE),virtual_dark,3840);
				return FALSE; // Return to game	
			}
			if (menu_y==31) return 2;
			if (menu_y==41) return 3;
		}
	}	
	return 0;
}
